import { IColurs } from 'colurs';
import { TablurPadding, ITablurOptions, ITablurBorder, ITablurTokens, ITablurColumn, TablurAlign, TablurBorder, ITablurColumnGlobal, TablurType } from './interfaces';
export declare class Tablur {
    options: ITablurOptions;
    border: ITablurBorder;
    debug: boolean;
    tokens: ITablurTokens;
    rows: ITablurColumn[][];
    colurs: IColurs;
    constructor(options?: ITablurOptions | boolean, debug?: boolean);
    private init;
    private pad;
    private shiftLine;
    private stringLength;
    private ensureString;
    padLeft(str: string, width: number, char: string): string;
    padCenter(str: string, width: number, char: string): string;
    padRight(str: string, width: number, char: string): string;
    getBorders(width: number, border: TablurBorder | ITablurBorder): {
        top: string;
        bottom: string;
        horizontal: string;
    };
    getMaxRow(rows: ITablurColumn[] | ITablurColumn[][], widthOnly?: boolean): {
        width: number;
        adjustment: number;
        count: number;
        columns: any[];
    };
    normalize(column: ITablurColumn): ITablurColumn[];
    normalize(columns: TablurType[] | ITablurColumn[], globals?: ITablurColumnGlobal): ITablurColumn[];
    normalize(text: TablurType): ITablurColumn[];
    normalize(text: TablurType, align: TablurAlign, padding?: TablurPadding): ITablurColumn[];
    normalize(text: TablurType, width: number, align?: TablurAlign, padding?: TablurPadding): ITablurColumn[];
    columnize(cols: ITablurColumn[], maxWidth: number, maxColumns: number[]): {
        row: string;
        padRow: string;
    };
    row(column: ITablurColumn): Tablur;
    row(columns: TablurType[] | ITablurColumn[], globals?: ITablurColumnGlobal): Tablur;
    row(text: TablurType): Tablur;
    row(text: TablurType, align: TablurAlign, padding?: TablurPadding): Tablur;
    row(text: TablurType, width: number, align?: TablurAlign, padding?: TablurPadding): Tablur;
    section(column: ITablurColumn): Tablur;
    section(text: TablurType): Tablur;
    section(text: TablurType, padding: TablurPadding): Tablur;
    section(text: TablurType, align: TablurAlign, padding?: TablurPadding): Tablur;
    repeat(text: string): Tablur;
    repeat(column: ITablurColumn): Tablur;
    repeat(text: string, padding: TablurPadding): Tablur;
    repeat(text: string, align: TablurAlign, padding?: TablurPadding): Tablur;
    break(): this;
    build(): string[];
    build(width: number): string[];
    build(row: ITablurColumn[], width?: number): string[];
    build(rows: ITablurColumn[][], width?: number): string[];
    toString(): string;
    render(wrap?: boolean): this;
    clear(): this;
    reset(options?: ITablurOptions | boolean, debug?: boolean): this;
}
